Arbor 3: FSM & BT Graph Editor 3.7.0

Public Member Functions | Public Attributes | Protected Member Functions | List of all members
CompositeNode Class Reference

This node controls the execution of child nodes. More...

Inheritance diagram for CompositeNode:

## Public Member Functions
| CompositeNode (NodeGraph nodeGraph, int nodeID, System.Type classType)
| Please use the BehaviourTreeInternal.CreateComposite(Vector2, System.Type) CompositeNode creating. More...
CompositeBehaviour | CreateCompositeBehaviour (System.Type classType)
| Create a CompositeBehaviour. More...
override bool | HasParentLinkSlot ()
| Whether this node has a NodeLinkSlot to parent. More...
override NodeLinkSlot | GetParentLinkSlot ()
| Get NodeLinkSlot to parent. More...
override bool | HasChildLinkSlot ()
| Whether this node has a NodeLinkSlot to child. More...
override string | GetName ()
| Get node name. More...
Public Member Functions inherited from TreeBehaviourNode
| TreeBehaviourNode (NodeGraph nodeGraph, int nodeID)
| TreeBehaviourNode constructor More...
Object | GetBehaviourObject ()
| Get Main Behaviour Object. More...
Decorator | AddDecorator (System.Type type)
| Adds the Decorator. More...
T | AddDecorator< T > ()
| Adds the Decorator. More...
Decorator | InsertDecorator (int index, System.Type type)
| Insert the Decorator. More...
T | InsertDecorator< T > (int index)
| Insert the Decorator. More...
Service | AddService (System.Type type)
| Adds the Service. More...
T | AddService< T > ()
| Adds the Service. More...
Service | InsertService (int index, System.Type type)
| Insert the Service. More...
T | InsertService< T > (int index)
| Insert the Service. More...
override bool | IsContainsBehaviour (NodeBehaviour behaviour)
| Check if it contains NodeBehaviour. More...
void | MoveDecorator (int fromIndex, TreeBehaviourNode toNode, int toIndex)
| Move the order of Decorator. More...
void | MoveService (int fromIndex, TreeBehaviourNode toNode, int toIndex)
| Move the order of Service. More...
void | DestroyBehaviour ()
| Destroy behaviour. More...
void | DestroyAllBehaviour ()
| Destroy all behaviour. More...
Public Member Functions inherited from TreeNodeBase
| TreeNodeBase (NodeGraph nodeGraph, int nodeID)
| TreeNodeBase constructor More...
override bool | IsDeletable ()
| Returns whether or not it can be deleted. More...
override string | ToString ()
| Convert node to string (for debugging). More...
Public Member Functions inherited from Node
| Node (NodeGraph nodeGraph, int nodeID)
| Node constructor More...
override string | ToString ()
| Convert node to string (for debugging). More...

## Public Attributes
NodeLinkSlot | parentLink = new NodeLinkSlot()
| Link to parent node More...
List< NodeLinkSlot > | childrenLink = new List<NodeLinkSlot>()
| Link to child nodes. More...
string | name = "New Composite"
| Node name. More...
Public Attributes inherited from Node
Rect | position
| Position on the Arbor Editor. More...
bool | showComment
| Whether to display comments More...
string | nodeComment
| Comment More...

## Protected Member Functions
override void | OnExecute ()
| Called when executing. More...
Protected Member Functions inherited from TreeBehaviourNode
override void | OnGraphChanged ()
| Called when the NodeGraph to which the Node belongs has changed. More...
void | SetBehaviour (TreeNodeBehaviour behaviour)
| Set Main Behaviour. More...

## Additional Inherited Members
Properties inherited from TreeBehaviourNode
TreeNodeBehaviour | behaviour`[get]`
| Main behaviour More...
DecoratorList | decoratorList`[get]`
| Decorator list More...
ServiceList | serviceList`[get]`
| Service list More...
bool | breakPoint`[get, set]`
| Break point. More...
Properties inherited from TreeNodeBase
bool | enablePriority`[get]`
| Returns true if it is traced from the root node and connected. More...
int | priority`[get]`
| The priority of the node. More...
BehaviourTreeInternal | behaviourTree`[get]`
| Gets the behaviour tree. More...
TreeNodeBase | parentNode`[get]`
| Get parent node. More...
NodeStatus | status`[get]`
| The state of the node. More...
bool | isActive`[get]`
| Returns true if it is active. More...
Properties inherited from Node
NodeGraph | nodeGraph`[get]`
| Gets the NodeGraph. More...
int | nodeID`[get]`
| Gets the node identifier. More...

## Detailed Description

This node controls the execution of child nodes.

## Constructor & Destructor Documentation

## ◆ CompositeNode()

CompositeNode | ( | NodeGraph | nodeGraph,
|  | int | nodeID,
|  | System.Type | classType
| ) |  |

Please use the BehaviourTreeInternal.CreateComposite(Vector2, System.Type) CompositeNode creating.

## Member Function Documentation

## ◆ CreateCompositeBehaviour()

CompositeBehaviour CreateCompositeBehaviour | ( | System.Type | classType | ) |

Create a CompositeBehaviour.

Use it in the editor.

## ◆ GetName()

override string GetName | ( |  | ) |
| virtual

Get node name.

Returns
  Node name

Reimplemented from Node.

## ◆ GetParentLinkSlot()

override NodeLinkSlot GetParentLinkSlot | ( |  | ) |
| virtual

Get NodeLinkSlot to parent.

Returns
  NodeLinkSlot to parent

Reimplemented from TreeNodeBase.

## ◆ HasChildLinkSlot()

override bool HasChildLinkSlot | ( |  | ) |
| virtual

Whether this node has a NodeLinkSlot to child.

Returns
  True if it has a NodeLinkSlot to child, false otherwise.

Implements TreeNodeBase.

## ◆ HasParentLinkSlot()

override bool HasParentLinkSlot | ( |  | ) |
| virtual

Whether this node has a NodeLinkSlot to parent.

Returns
  True if it has a NodeLinkSlot to parent, false otherwise.

Implements TreeNodeBase.

## ◆ OnExecute()

override void OnExecute | ( |  | ) |
| protected virtual

Called when executing.

Implements TreeNodeBase.

## Member Data Documentation

## ◆ childrenLink

List<NodeLinkSlot> childrenLink = new List<NodeLinkSlot>()

Link to child nodes.

## ◆ name

string name = "New Composite"

Node name.

## ◆ parentLink

NodeLinkSlot parentLink = new NodeLinkSlot()

Link to parent node